
public class Tester
{
	public static void main( String args[] )
	{
		StudentList studes = new StudentList();
		studes.add(new Student("ALEX SMART", 4, 4.0));
		studes.add(new Student("BOBO BEAR", 4, 2.0));
		studes.add(new Student("HAPPY JUNIOR", 3, 3.3));
		studes.add(new Student("JAZ PASSED", 2, 2.0));
		studes.add(new Student("PROMIL KID", 1, 4.0));
		studes.add(new Student("SAM FRESHMAN", 1, 3.5));
		studes.add(new Student("WILL GRADUATE", 4, 3.0));
		
		Student s = studes.find( "PROMIL KID" );
		if ( s != null )
		{
			System.out.println( s );
		}
		
		// iterate through all students
		// using iterator pattern
		
		//list all students
		System.out.println( "-----" );
		StudentListIterator it = studes.getIterator();
		for( it.first(); it.hasNext(); it.next() )
		{
			System.out.println( it.getCurrent() );
		}
		
		//list all pairs of student names (BUGGY!)
		System.out.println( "-----" );
		StudentListIterator it1 = studes.getIterator();
		for( it1.first(); it1.hasNext(); it1.next() )
		{
			String name1 = it1.getCurrent().getName();
			StudentListIterator it2 = studes.getIterator();
			for( it2.first(); it2.hasNext(); it2.next() )
			{
				String name2 = it2.getCurrent().getName();
				if (name1.compareTo( name2 ) < 0)
				{
					System.out.println( name1 + "," + name2 );
				}
			}
			
		}
		
		// TODO: implement a "reverse" iterator inside StudentList,
		// where the list is printed in reverse order
		// uncomment the following when done
		
		
		// System.out.println( "-----" );
		// it = studes.getReverseIterator();
		// for( it.first(); it.hasNext(); it.next() )
		// {
		//	System.out.println( it.getCurrent() );
		// }

	}
}
