
/**
 * Class for Student objects storing name, year and QPI.
 * 
 * @author JP Vergara 
 * @version 1.0
 */
 
package students;
 
public class Student
{
    private String name;
    private int year;
    private double qpi;

    /**
     * Constructor for objects of class Student
     * 
     * @param n    name of student
     * @param y    year
     * @param q    qpi
     * 
     */
    public Student( String n, int y, double q )
    {
    	name = n;
    	year = y;
    	qpi = q;
    }

    public String getName( )
    {
        return name;
    }

    public int getYear( )
    {
        return year;
    }

    public double getQPI( )
    {
        return qpi;
    }
    
    public String toString()
    {
    	return name + ": year " + year + ", qpi " + qpi;
    }

}
